Index: boot/arch/amd64/Makefile.inc
===================================================================
--- boot/arch/amd64/Makefile.inc	(revision 291b8bc66a941bac60fdea3ad481eb7b27bfcf40)
+++ boot/arch/amd64/Makefile.inc	(revision 889e8e3c68f741489743165141ddb4ccfad90112)
@@ -49,5 +49,5 @@
 	usbflbk \
 	usbhub \
-	usbkbd \
+	usbhid \
 	usbmid \
 	usbmouse \
Index: kernel/generic/src/console/console.c
===================================================================
--- kernel/generic/src/console/console.c	(revision 291b8bc66a941bac60fdea3ad481eb7b27bfcf40)
+++ kernel/generic/src/console/console.c	(revision 889e8e3c68f741489743165141ddb4ccfad90112)
@@ -53,14 +53,5 @@
 #include <str.h>
 
-/*
- * devman produces a lot of output and by giving so many pages
- * we to allow /app/klog to catch-up.
- */
-#ifdef CONFIG_DEVMAN_EARLY_LAUNCH
-#define KLOG_PAGES    64
-#else
 #define KLOG_PAGES    4
-#endif
-
 #define KLOG_LENGTH   (KLOG_PAGES * PAGE_SIZE / sizeof(wchar_t))
 #define KLOG_LATENCY  8
Index: kernel/generic/src/mm/as.c
===================================================================
--- kernel/generic/src/mm/as.c	(revision 291b8bc66a941bac60fdea3ad481eb7b27bfcf40)
+++ kernel/generic/src/mm/as.c	(revision 889e8e3c68f741489743165141ddb4ccfad90112)
@@ -1949,5 +1949,5 @@
 sysarg_t sys_as_area_create(uintptr_t address, size_t size, unsigned int flags)
 {
-	if (as_area_create(AS, flags, size, address,
+	if (as_area_create(AS, flags | AS_AREA_CACHEABLE, size, address,
 	    AS_AREA_ATTR_NONE, &anon_backend, NULL))
 		return (sysarg_t) address;
Index: uspace/Makefile
===================================================================
--- uspace/Makefile	(revision 291b8bc66a941bac60fdea3ad481eb7b27bfcf40)
+++ uspace/Makefile	(revision 889e8e3c68f741489743165141ddb4ccfad90112)
@@ -122,5 +122,5 @@
 		drv/uhci-rhd \
 		drv/usbflbk \
-		drv/usbkbd \
+		drv/usbhid \
 		drv/usbhub \
 		drv/usbmid \
@@ -142,5 +142,5 @@
 		drv/uhci-rhd \
 		drv/usbflbk \
-		drv/usbkbd \
+		drv/usbhid \
 		drv/usbhub \
 		drv/usbmid \
Index: uspace/app/init/init.c
===================================================================
--- uspace/app/init/init.c	(revision 291b8bc66a941bac60fdea3ad481eb7b27bfcf40)
+++ uspace/app/init/init.c	(revision 889e8e3c68f741489743165141ddb4ccfad90112)
@@ -288,4 +288,8 @@
 	
 	spawn("/srv/clip");
+
+#ifdef CONFIG_DEVMAN_EARLY_LAUNCH
+	spawn("/srv/devman");
+#endif
 	
 	/*
@@ -314,7 +318,5 @@
 	getterm("term/vc6", "/app/klog", false);
 
-#ifdef CONFIG_DEVMAN_EARLY_LAUNCH
-	spawn("/srv/devman");
-#else
+#ifndef CONFIG_DEVMAN_EARLY_LAUNCH
 	getterm("term/vc7", "/srv/devman", false);
 #endif
Index: uspace/drv/ohci/Makefile
===================================================================
--- uspace/drv/ohci/Makefile	(revision 291b8bc66a941bac60fdea3ad481eb7b27bfcf40)
+++ uspace/drv/ohci/Makefile	(revision 889e8e3c68f741489743165141ddb4ccfad90112)
@@ -37,5 +37,4 @@
 	main.c \
 	hc.c \
-	ohci.c \
 	root_hub.c \
 	pci.c
Index: uspace/drv/ohci/batch.c
===================================================================
--- uspace/drv/ohci/batch.c	(revision 291b8bc66a941bac60fdea3ad481eb7b27bfcf40)
+++ uspace/drv/ohci/batch.c	(revision 889e8e3c68f741489743165141ddb4ccfad90112)
@@ -118,5 +118,5 @@
 	instance->next_step = batch_call_in_and_dispose;
 	/* TODO: implement */
-	usb_log_debug("Batch(%p) CONTROL READ initialized.\n", instance);
+	usb_log_debug("Batch(%p) CONTROL WRITE initialized.\n", instance);
 }
 /*----------------------------------------------------------------------------*/
Index: uspace/drv/ohci/hc.c
===================================================================
--- uspace/drv/ohci/hc.c	(revision 291b8bc66a941bac60fdea3ad481eb7b27bfcf40)
+++ uspace/drv/ohci/hc.c	(revision 889e8e3c68f741489743165141ddb4ccfad90112)
@@ -39,4 +39,5 @@
 #include <usb/debug.h>
 #include <usb/usb.h>
+#include <usb/hub.h>
 #include <usb/ddfiface.h>
 #include <usb/usbdevice.h>
@@ -44,31 +45,6 @@
 #include "hc.h"
 
+static int dummy_reset(int foo, void *arg);
 static int interrupt_emulator(hc_t *instance);
-/*----------------------------------------------------------------------------*/
-int hc_register_hub(hc_t *instance, ddf_fun_t *hub_fun)
-{
-	assert(instance);
-	assert(hub_fun);
-
-	usb_address_t hub_address =
-	    device_keeper_get_free_address(&instance->manager, USB_SPEED_FULL);
-	instance->rh.address = hub_address;
-	usb_device_keeper_bind(
-	    &instance->manager, hub_address, hub_fun->handle);
-
-	char *match_str = NULL;
-	int ret = asprintf(&match_str, "usb&mid");
-	ret = (match_str == NULL) ? ret : EOK;
-	if (ret < 0) {
-		usb_log_error("Failed to create root hub match-id string.\n");
-		return ret;
-	}
-
-	ret = ddf_fun_add_match_id(hub_fun, match_str, 100);
-	if (ret != EOK) {
-		usb_log_error("Failed add create root hub match-id.\n");
-	}
-	return ret;
-}
 /*----------------------------------------------------------------------------*/
 int hc_init(hc_t *instance, ddf_fun_t *fun, ddf_dev_t *dev,
@@ -92,7 +68,44 @@
 	}
 
+
 	rh_init(&instance->rh, dev, instance->registers);
+	/* TODO: implement */
+	return EOK;
+}
+/*----------------------------------------------------------------------------*/
+int hc_register_hub(hc_t *instance)
+{
+	async_usleep(1000000);
+#define CHECK_RET_RETURN(ret, msg...) \
+	if (ret != EOK) { \
+		usb_log_error(msg); \
+		return ret; \
+	} else (void)0
+	assert(instance);
+	assert(instance->ddf_instance);
+	assert(instance->ddf_instance->handle);
+	ddf_dev_t *dev = instance->rh.device;
+	int ret = EOK;
 
-	/* TODO: implement */
+	usb_hc_connection_t conn;
+	ret =
+	    usb_hc_connection_initialize(&conn, instance->ddf_instance->handle);
+	CHECK_RET_RETURN(ret, "Failed to initialize hc connection.\n");
+
+	ret = usb_hc_connection_open(&conn);
+	CHECK_RET_RETURN(ret, "Failed to open hc connection.\n");
+
+	usb_address_t address;
+	devman_handle_t handle;
+	ret = usb_hc_new_device_wrapper(dev, &conn, USB_SPEED_FULL, dummy_reset,
+	    0, instance, &address, &handle, NULL, NULL, NULL);
+	if (ret != EOK) {
+		usb_log_error("Failed to add rh device.\n");
+		instance->rh.address = -1;
+		return ret;
+	}
+
+	ret = usb_hc_connection_close(&conn);
+	CHECK_RET_RETURN(ret, "Failed to close hc connection.\n");
 	return EOK;
 }
@@ -121,5 +134,13 @@
 }
 /*----------------------------------------------------------------------------*/
-int interrupt_emulator(hc_t *instance)
+static int dummy_reset(int foo, void *arg)
+{
+	hc_t *hc = (hc_t*)arg;
+	assert(hc);
+	hc->rh.address = 0;
+	return EOK;
+}
+/*----------------------------------------------------------------------------*/
+static int interrupt_emulator(hc_t *instance)
 {
 	assert(instance);
Index: uspace/drv/ohci/hc.h
===================================================================
--- uspace/drv/ohci/hc.h	(revision 291b8bc66a941bac60fdea3ad481eb7b27bfcf40)
+++ uspace/drv/ohci/hc.h	(revision 889e8e3c68f741489743165141ddb4ccfad90112)
@@ -57,8 +57,8 @@
 } hc_t;
 
-int hc_register_hub(hc_t *instance, ddf_fun_t *hub_fun);
-
 int hc_init(hc_t *instance, ddf_fun_t *fun, ddf_dev_t *dev,
      uintptr_t regs, size_t reg_size, bool interrupts);
+
+int hc_register_hub(hc_t *instance);
 
 int hc_schedule(hc_t *instance, usb_transfer_batch_t *batch);
Index: uspace/drv/ohci/iface.h
===================================================================
--- uspace/drv/ohci/iface.h	(revision 291b8bc66a941bac60fdea3ad481eb7b27bfcf40)
+++ uspace/drv/ohci/iface.h	(revision 889e8e3c68f741489743165141ddb4ccfad90112)
@@ -33,8 +33,10 @@
  * Common OHCI definitions.
  */
-#ifndef DRV_OHCI_IFACE_H
-#define DRV_OHCI_IFACE_H
+#ifndef DRV_OHCI_OHCI_H
+#define DRV_OHCI_OHCI_H
 
 #include <usbhc_iface.h>
+
+#define NAME "ohci"
 
 extern usbhc_iface_t hc_iface;
Index: uspace/drv/ohci/main.c
===================================================================
--- uspace/drv/ohci/main.c	(revision 291b8bc66a941bac60fdea3ad481eb7b27bfcf40)
+++ uspace/drv/ohci/main.c	(revision 889e8e3c68f741489743165141ddb4ccfad90112)
@@ -34,14 +34,57 @@
  */
 #include <ddf/driver.h>
+#include <ddf/interrupt.h>
+#include <device/hw_res.h>
 #include <errno.h>
 #include <str_error.h>
 
+#include <usb_iface.h>
+#include <usb/ddfiface.h>
 #include <usb/debug.h>
 
-#include "ohci.h"
-
-#define NAME "ohci"
+#include "pci.h"
+#include "iface.h"
+#include "hc.h"
 
 static int ohci_add_device(ddf_dev_t *device);
+static int get_hc_handle(ddf_fun_t *fun, devman_handle_t *handle)
+{
+	assert(handle);
+  assert(fun != NULL);
+
+  *handle = fun->handle;
+  return EOK;
+}
+/*----------------------------------------------------------------------------*/
+static int get_address(
+    ddf_fun_t *fun, devman_handle_t handle, usb_address_t *address)
+{
+	assert(fun);
+	usb_device_keeper_t *manager = &fun_to_hc(fun)->manager;
+  usb_address_t addr = usb_device_keeper_find(manager, handle);
+  if (addr < 0) {
+    return addr;
+  }
+
+  if (address != NULL) {
+    *address = addr;
+  }
+
+  return EOK;
+}
+/*----------------------------------------------------------------------------*/
+/** IRQ handling callback, identifies device
+ *
+ * @param[in] dev DDF instance of the device to use.
+ * @param[in] iid (Unused).
+ * @param[in] call Pointer to the call that represents interrupt.
+ */
+static void irq_handler(ddf_dev_t *dev, ipc_callid_t iid, ipc_call_t *call)
+{
+	assert(dev);
+	hc_t *hc = (hc_t*)dev->driver_data;
+	assert(hc);
+	hc_interrupt(hc, 0);
+}
 /*----------------------------------------------------------------------------*/
 static driver_ops_t ohci_driver_ops = {
@@ -54,4 +97,14 @@
 };
 /*----------------------------------------------------------------------------*/
+static usb_iface_t hc_usb_iface = {
+	.get_address = get_address,
+	.get_hc_handle = get_hc_handle,
+};
+/*----------------------------------------------------------------------------*/
+static ddf_dev_ops_t hc_ops = {
+	.interfaces[USB_DEV_IFACE] = &hc_usb_iface,
+	.interfaces[USBHC_DEV_IFACE] = &hc_iface,
+};
+/*----------------------------------------------------------------------------*/
 /** Initializes a new ddf driver instance of OHCI hcd.
  *
@@ -59,25 +112,86 @@
  * @return Error code.
  */
-int ohci_add_device(ddf_dev_t *device)
-{
-	usb_log_debug("ohci_add_device() called\n");
+static int ohci_add_device(ddf_dev_t *device)
+{
 	assert(device);
-	ohci_t *ohci = malloc(sizeof(ohci_t));
-	if (ohci == NULL) {
+#define CHECK_RET_RETURN(ret, message...) \
+if (ret != EOK) { \
+	usb_log_error(message); \
+	return ret; \
+}
+
+	uintptr_t mem_reg_base = 0;
+	size_t mem_reg_size = 0;
+	int irq = 0;
+
+	int ret =
+	    pci_get_my_registers(device, &mem_reg_base, &mem_reg_size, &irq);
+	CHECK_RET_RETURN(ret,
+	    "Failed(%d) to get memory addresses:.\n", ret, device->handle);
+	usb_log_info("Memory mapped regs at 0x%X (size %zu), IRQ %d.\n",
+	    mem_reg_base, mem_reg_size, irq);
+
+	ret = pci_disable_legacy(device);
+	CHECK_RET_RETURN(ret,
+	    "Failed(%d) disable legacy USB: %s.\n", ret, str_error(ret));
+
+	hc_t *hcd = malloc(sizeof(hc_t));
+	if (hcd == NULL) {
 		usb_log_error("Failed to allocate OHCI driver.\n");
 		return ENOMEM;
 	}
 
-	int ret = ohci_init(ohci, device);
+	ddf_fun_t *hc_fun = ddf_fun_create(device, fun_exposed, "ohci-hc");
+	if (hc_fun == NULL) {
+		usb_log_error("Failed to create OHCI function.\n");
+		free(hcd);
+		return ENOMEM;
+	}
+
+
+	bool interrupts = false;
+#ifdef CONFIG_USBHC_NO_INTERRUPTS
+	usb_log_warning("Interrupts disabled in OS config, " \
+	    "falling back to polling.\n");
+#else
+	ret = pci_enable_interrupts(device);
 	if (ret != EOK) {
-		usb_log_error("Failed to initialize OHCI driver: %s.\n",
+		usb_log_warning("Failed to enable interrupts: %s.\n",
 		    str_error(ret));
+		usb_log_info("HW interrupts not available, " \
+		    "falling back to polling.\n");
+	} else {
+		usb_log_debug("Hw interrupts enabled.\n");
+		interrupts = true;
+	}
+#endif
+
+	ret = hc_init(hcd, hc_fun, device, mem_reg_base, mem_reg_size, interrupts);
+	if (ret != EOK) {
+		usb_log_error("Failed to initialize OHCI driver.\n");
+		free(hcd);
 		return ret;
 	}
-	device->driver_data = ohci;
-
-	usb_log_info("Controlling new OHCI device `%s'.\n", device->name);
+
+	ret = register_interrupt_handler(device, irq, irq_handler, NULL);
+
+	hc_fun->ops = &hc_ops;
+	ret = ddf_fun_bind(hc_fun);
+	if (ret != EOK) {
+		usb_log_error("Failed to bind OHCI function.\n");
+		ddf_fun_destroy(hc_fun);
+		free(hcd);
+		return ret;
+	}
+	hc_fun->driver_data = hcd;
+
+	fid_t later = fibril_create((int(*)(void*))hc_register_hub, hcd);
+	fibril_add_ready(later);
+
+	usb_log_info("Controlling new OHCI device `%s' (handle %llu).\n",
+	    device->name, device->handle);
 
 	return EOK;
+#undef CHECK_RET_RETURN
 }
 /*----------------------------------------------------------------------------*/
Index: uspace/drv/ohci/root_hub.c
===================================================================
--- uspace/drv/ohci/root_hub.c	(revision 291b8bc66a941bac60fdea3ad481eb7b27bfcf40)
+++ uspace/drv/ohci/root_hub.c	(revision 889e8e3c68f741489743165141ddb4ccfad90112)
@@ -39,61 +39,4 @@
 
 #include "root_hub.h"
-#include "usb/classes/classes.h"
-#include <usb/request.h>
-#include <usb/classes/hub.h>
-
-static const usb_standard_device_descriptor_t ohci_rh_device_descriptor =
-{
-		.configuration_count = 1,
-		.descriptor_type = USB_DESCTYPE_DEVICE,
-		.device_class = USB_CLASS_HUB,
-		.device_protocol = 0,
-		.device_subclass = 0,
-		.device_version = 0,
-		.length = sizeof(usb_standard_device_descriptor_t),
-		/// \TODO this value is guessed
-		.max_packet_size = 8,
-		.vendor_id = 0x16db,
-		.product_id = 0x0001,
-		/// \TODO these values migt be different
-		.str_serial_number = 0,
-		.usb_spec_version = 0,
-};
-
-static const usb_standard_configuration_descriptor_t ohci_rh_conf_descriptor =
-{
-	/// \TODO some values are default or guessed
-	.attributes = 1<<7,
-	.configuration_number = 1,
-	.descriptor_type = USB_DESCTYPE_CONFIGURATION,
-	.interface_count = 1,
-	.length = sizeof(usb_standard_configuration_descriptor_t),
-	.max_power = 100,
-	.str_configuration = 0,
-};
-
-static const usb_standard_interface_descriptor_t ohci_rh_iface_descriptor =
-{
-	.alternate_setting = 0,
-	.descriptor_type = USB_DESCTYPE_INTERFACE,
-	.endpoint_count = 1,
-	.interface_class = USB_CLASS_HUB,
-	/// \TODO is this correct?
-	.interface_number = 1,
-	.interface_protocol = 0,
-	.interface_subclass = 0,
-	.length = sizeof(usb_standard_interface_descriptor_t),
-	.str_interface = 0,
-};
-
-static const usb_standard_endpoint_descriptor_t ohci_rh_ep_descriptor =
-{
-	.attributes = USB_TRANSFER_INTERRUPT,
-	.descriptor_type = USB_DESCTYPE_ENDPOINT,
-	.endpoint_address = 1 + (1<<7),
-	.length = sizeof(usb_standard_endpoint_descriptor_t),
-	.max_packet_size = 8,
-	.poll_interval = 255,
-};
 
 /** Root hub initialization
@@ -107,477 +50,24 @@
 	instance->device = dev;
 
-
 	usb_log_info("OHCI root hub with %d ports.\n", regs->rh_desc_a & 0xff);
 
-	//start generic usb hub driver
-	
 	/* TODO: implement */
 	return EOK;
 }
 /*----------------------------------------------------------------------------*/
-
-
-static int process_get_port_status_request(rh_t *instance, uint16_t port,
-		usb_transfer_batch_t * request){
-	if(port<1 || port>instance->port_count)
-		return EINVAL;
-	uint32_t * uint32_buffer = (uint32_t*)request->buffer;
-	request->transfered_size = 4;
-	uint32_buffer[0] = instance->registers->rh_port_status[port -1];
-	return EOK;
-}
-
-static int process_get_hub_status_request(rh_t *instance,
-		usb_transfer_batch_t * request){
-	uint32_t * uint32_buffer = (uint32_t*)request->buffer;
-	//bits, 0,1,16,17
-	request->transfered_size = 4;
-	uint32_t mask = 1 & (1<<1) & (1<<16) & (1<<17);
-	uint32_buffer[0] = mask & instance->registers->rh_status;
-	return EOK;
-
-}
-
-static void usb_create_serialized_hub_descriptor(rh_t *instance, uint8_t ** out_result,
-		size_t * out_size) {
-	//base size
-	size_t size = 7;
-	//variable size according to port count
-	size_t var_size = instance->port_count / 8 +
-			((instance->port_count % 8 > 0) ? 1 : 0);
-	size += 2 * var_size;
-	uint8_t * result = (uint8_t*) malloc(size);
-	bzero(result,size);
-	//size
-	result[0] = size;
-	//descriptor type
-	result[1] = USB_DESCTYPE_HUB;
-	result[2] = instance->port_count;
-	uint32_t hub_desc_reg = instance->registers->rh_desc_a;
-	result[3] = 
-			((hub_desc_reg >> 8) %2) +
-			(((hub_desc_reg >> 9) %2) << 1) +
-			(((hub_desc_reg >> 10) %2) << 2) +
-			(((hub_desc_reg >> 11) %2) << 3) +
-			(((hub_desc_reg >> 12) %2) << 4);
-	result[4] = 0;
-	result[5] = /*descriptor->pwr_on_2_good_time*/ 50;
-	result[6] = 50;
-
-	int port;
-	for (port = 1; port <= instance->port_count; ++port) {
-		result[7 + port/8] +=
-				((instance->registers->rh_desc_b >> port)%2) << (port%8);
-	}
-	size_t i;
-	for (i = 0; i < var_size; ++i) {
-		result[7 + var_size + i] = 255;
-	}
-	(*out_result) = result;
-	(*out_size) = size;
-}
-
-
-static int process_get_status_request(rh_t *instance,
-		usb_transfer_batch_t * request)
-{
-	size_t buffer_size = request->buffer_size;
-	usb_device_request_setup_packet_t * request_packet =
-			(usb_device_request_setup_packet_t*)
-			request->setup_buffer;
-
-	usb_hub_bm_request_type_t request_type = request_packet->request_type;
-	if(buffer_size<4/*request_packet->length*/){///\TODO
-		usb_log_warning("requested more data than buffer size\n");
-		return EINVAL;
-	}
-
-	if(request_type == USB_HUB_REQ_TYPE_GET_HUB_STATUS)
-		return process_get_hub_status_request(instance, request);
-	if(request_type == USB_HUB_REQ_TYPE_GET_PORT_STATUS)
-		return process_get_port_status_request(instance, request_packet->index,
-				request);
-	return ENOTSUP;
-}
-
-static void create_interrupt_mask(rh_t *instance, void ** buffer,
-		size_t * buffer_size){
-	int bit_count = instance->port_count + 1;
-	(*buffer_size) = (bit_count / 8) + (bit_count%8==0)?0:1;
-	(*buffer) = malloc(*buffer_size);
-	uint8_t * bitmap = (uint8_t*)(*buffer);
-	uint32_t mask = (1<<16) + (1<<17);
-	bzero(bitmap,(*buffer_size));
-	if(instance->registers->rh_status & mask){
-		bitmap[0] = 1;
-	}
-	int port;
-	mask = 0;
-	int i;
-	for(i=16;i<=20;++i)
-		mask += 1<<i;
-	for(port = 1; port<=instance->port_count;++port){
-		if(mask & instance->registers->rh_port_status[port-1]){
-			bitmap[(port+1)/8] += 1<<(port%8);
-		}
-	}
-}
-
-
-static int process_get_descriptor_request(rh_t *instance,
-		usb_transfer_batch_t *request){
-	/// \TODO
-	usb_device_request_setup_packet_t * setup_request =
-			(usb_device_request_setup_packet_t*)request->setup_buffer;
-	size_t size;
-	const void * result_descriptor;
-	const uint16_t setup_request_value = setup_request->value_high;
-			//(setup_request->value_low << 8);
-	bool del = false;
-
-	switch (setup_request_value)
-	{
-	case USB_DESCTYPE_HUB: {
-		uint8_t * descriptor;
-		usb_create_serialized_hub_descriptor(
-		    instance, &descriptor, &size);
-		result_descriptor = descriptor;
-		break;
-	}
-	case USB_DESCTYPE_DEVICE: {
-		usb_log_debug("USB_DESCTYPE_DEVICE\n");
-		result_descriptor = &ohci_rh_device_descriptor;
-		size = sizeof(ohci_rh_device_descriptor);
-		break;
-	}
-	case USB_DESCTYPE_CONFIGURATION: {
-		usb_log_debug("USB_DESCTYPE_CONFIGURATION\n");
-		usb_standard_configuration_descriptor_t * descriptor =
-				malloc(sizeof(usb_standard_configuration_descriptor_t));
-		memcpy(descriptor, &ohci_rh_conf_descriptor,
-		    sizeof(usb_standard_configuration_descriptor_t));
-		/// \TODO should this include device descriptor?
-		const size_t hub_descriptor_size = 7 +
-				2* (instance->port_count / 8 +
-				((instance->port_count % 8 > 0) ? 1 : 0));
-		descriptor->total_length =
-				sizeof(usb_standard_configuration_descriptor_t)+
-				sizeof(usb_standard_endpoint_descriptor_t)+
-				sizeof(usb_standard_interface_descriptor_t)+
-				hub_descriptor_size;
-		result_descriptor = descriptor;
-		size = sizeof(usb_standard_configuration_descriptor_t);
-		del = true;
-		break;
-	}
-	case USB_DESCTYPE_INTERFACE: {
-		usb_log_debug("USB_DESCTYPE_INTERFACE\n");
-		result_descriptor = &ohci_rh_iface_descriptor;
-		size = sizeof(ohci_rh_iface_descriptor);
-		break;
-	}
-	case USB_DESCTYPE_ENDPOINT: {
-		usb_log_debug("USB_DESCTYPE_ENDPOINT\n");
-		result_descriptor = &ohci_rh_ep_descriptor;
-		size = sizeof(ohci_rh_ep_descriptor);
-		break;
-	}
-	default: {
-		usb_log_debug("USB_DESCTYPE_EINVAL %d \n",setup_request->value);
-		usb_log_debug("\ttype %d\n\trequest %d\n\tvalue %d\n\tindex %d\n\tlen %d\n ",
-				setup_request->request_type,
-				setup_request->request,
-				setup_request_value,
-				setup_request->index,
-				setup_request->length
-				);
-		return EINVAL;
-	}
-	}
-#if 0
-	if(setup_request_value == USB_DESCTYPE_HUB){
-		usb_log_debug("USB_DESCTYPE_HUB\n");
-		//create hub descriptor
-		uint8_t * descriptor;
-		usb_create_serialized_hub_descriptor(instance, 
-				&descriptor, &size);
-		result_descriptor = descriptor;
-	}else if(setup_request_value == USB_DESCTYPE_DEVICE){
-		//create std device descriptor
-		usb_log_debug("USB_DESCTYPE_DEVICE\n");
-		usb_standard_device_descriptor_t * descriptor =
-				(usb_standard_device_descriptor_t*)
-				malloc(sizeof(usb_standard_device_descriptor_t));
-		descriptor->configuration_count = 1;
-		descriptor->descriptor_type = USB_DESCTYPE_DEVICE;
-		descriptor->device_class = USB_CLASS_HUB;
-		descriptor->device_protocol = 0;
-		descriptor->device_subclass = 0;
-		descriptor->device_version = 0;
-		descriptor->length = sizeof(usb_standard_device_descriptor_t);
-		/// \TODO this value is guessed
-		descriptor->max_packet_size = 8;
-		descriptor->product_id = 0x0001;
-		/// \TODO these values migt be different
-		descriptor->str_serial_number = 0;
-		descriptor->str_serial_number = 0;
-		descriptor->usb_spec_version = 0;
-		descriptor->vendor_id = 0x16db;
-		result_descriptor = descriptor;
-		size = sizeof(usb_standard_device_descriptor_t);
-	}else if(setup_request_value == USB_DESCTYPE_CONFIGURATION){
-		usb_log_debug("USB_DESCTYPE_CONFIGURATION\n");
-		usb_standard_configuration_descriptor_t * descriptor =
-				(usb_standard_configuration_descriptor_t*)
-				malloc(sizeof(usb_standard_configuration_descriptor_t));
-		/// \TODO some values are default or guessed
-		descriptor->attributes = 1<<7;
-		descriptor->configuration_number = 1;
-		descriptor->descriptor_type = USB_DESCTYPE_CONFIGURATION;
-		descriptor->interface_count = 1;
-		descriptor->length = sizeof(usb_standard_configuration_descriptor_t);
-		descriptor->max_power = 100;
-		descriptor->str_configuration = 0;
-		/// \TODO should this include device descriptor?
-		size_t hub_descriptor_size = 7 +
-				2* (instance->port_count / 8 +
-				((instance->port_count % 8 > 0) ? 1 : 0));
-		descriptor->total_length =
-				sizeof(usb_standard_configuration_descriptor_t)+
-				sizeof(usb_standard_endpoint_descriptor_t)+
-				sizeof(usb_standard_interface_descriptor_t)+
-				hub_descriptor_size;
-		result_descriptor = descriptor;
-		size = sizeof(usb_standard_configuration_descriptor_t);
-
-	}else if(setup_request_value == USB_DESCTYPE_INTERFACE){
-		usb_log_debug("USB_DESCTYPE_INTERFACE\n");
-		usb_standard_interface_descriptor_t * descriptor =
-				(usb_standard_interface_descriptor_t*)
-				malloc(sizeof(usb_standard_interface_descriptor_t));
-		descriptor->alternate_setting = 0;
-		descriptor->descriptor_type = USB_DESCTYPE_INTERFACE;
-		descriptor->endpoint_count = 1;
-		descriptor->interface_class = USB_CLASS_HUB;
-		/// \TODO is this correct?
-		descriptor->interface_number = 1;
-		descriptor->interface_protocol = 0;
-		descriptor->interface_subclass = 0;
-		descriptor->length = sizeof(usb_standard_interface_descriptor_t);
-		descriptor->str_interface = 0;
-		result_descriptor = descriptor;
-		size = sizeof(usb_standard_interface_descriptor_t);
-	}else if(setup_request_value == USB_DESCTYPE_ENDPOINT){
-		usb_log_debug("USB_DESCTYPE_ENDPOINT\n");
-		usb_standard_endpoint_descriptor_t * descriptor =
-				(usb_standard_endpoint_descriptor_t*)
-				malloc(sizeof(usb_standard_endpoint_descriptor_t));
-		descriptor->attributes = USB_TRANSFER_INTERRUPT;
-		descriptor->descriptor_type = USB_DESCTYPE_ENDPOINT;
-		descriptor->endpoint_address = 1 + (1<<7);
-		descriptor->length = sizeof(usb_standard_endpoint_descriptor_t);
-		descriptor->max_packet_size = 8;
-		descriptor->poll_interval = 255;
-		result_descriptor = descriptor;
-		size = sizeof(usb_standard_endpoint_descriptor_t);
-	}else{
-		usb_log_debug("USB_DESCTYPE_EINVAL %d \n",setup_request->value);
-		usb_log_debug("\ttype %d\n\trequest %d\n\tvalue %d\n\tindex %d\n\tlen %d\n ",
-				setup_request->request_type,
-				setup_request->request,
-				setup_request_value,
-				setup_request->index,
-				setup_request->length
-				);
-		return EINVAL;
-	}
-#endif
-	if(request->buffer_size < size){
-		size = request->buffer_size;
-	}
-	request->transfered_size = size;
-	memcpy(request->buffer,result_descriptor,size);
-	if (del)
-		free(result_descriptor);
-	return EOK;
-}
-
-static int process_get_configuration_request(rh_t *instance, 
-		usb_transfer_batch_t *request){
-	//set and get configuration requests do not have any meaning, only dummy
-	//values are returned
-	if(request->buffer_size != 1)
-		return EINVAL;
-	request->buffer[0] = 1;
-	request->transfered_size = 1;
-	return EOK;
-}
-
-static int process_hub_feature_set_request(rh_t *instance,
-		uint16_t feature, bool enable){
-	if(feature > USB_HUB_FEATURE_C_HUB_OVER_CURRENT)
-		return EINVAL;
-	instance->registers->rh_status =
-			enable ?
-			(instance->registers->rh_status | (1<<feature))
-			:
-			(instance->registers->rh_status & (~(1<<feature)));
-	/// \TODO any error?
-	return EOK;
-}
-
-static int process_port_feature_set_request(rh_t *instance,
-		uint16_t feature, uint16_t port, bool enable){
-	if(feature > USB_HUB_FEATURE_C_PORT_RESET)
-		return EINVAL;
-	if(port<1 || port>instance->port_count)
-		return EINVAL;
-	instance->registers->rh_port_status[port - 1] =
-			enable ?
-			(instance->registers->rh_port_status[port - 1] | (1<<feature))
-			:
-			(instance->registers->rh_port_status[port - 1] & (~(1<<feature)));
-	/// \TODO any error?
-	return EOK;
-}
-
-static int process_address_set_request(rh_t *instance,
-		uint16_t address){
-	instance->address = address;
-	return EOK;
-}
-
-static int process_request_with_output(rh_t *instance,
-		usb_transfer_batch_t *request){
-	usb_device_request_setup_packet_t * setup_request =
-			(usb_device_request_setup_packet_t*)request->setup_buffer;
-	if(setup_request->request == USB_DEVREQ_GET_STATUS){
-		usb_log_debug("USB_DEVREQ_GET_STATUS\n");
-		return process_get_status_request(instance, request);
-	}
-	if(setup_request->request == USB_DEVREQ_GET_DESCRIPTOR){
-		usb_log_debug("USB_DEVREQ_GET_DESCRIPTOR\n");
-		return process_get_descriptor_request(instance, request);
-	}
-	if(setup_request->request == USB_DEVREQ_GET_CONFIGURATION){
-		usb_log_debug("USB_DEVREQ_GET_CONFIGURATION\n");
-		return process_get_configuration_request(instance, request);
-	}
-	return ENOTSUP;
-}
-
-static int process_request_with_input(rh_t *instance,
-		usb_transfer_batch_t *request){
-	usb_device_request_setup_packet_t * setup_request =
-			(usb_device_request_setup_packet_t*)request->setup_buffer;
-	request->transfered_size = 0;
-	if(setup_request->request == USB_DEVREQ_SET_DESCRIPTOR){
-		return ENOTSUP;
-	}
-	if(setup_request->request == USB_DEVREQ_SET_CONFIGURATION){
-		//set and get configuration requests do not have any meaning,
-		//only dummy values are returned
-		return EOK;
-	}
-	return ENOTSUP;
-}
-
-
-static int process_request_without_data(rh_t *instance,
-		usb_transfer_batch_t *request){
-	usb_device_request_setup_packet_t * setup_request =
-			(usb_device_request_setup_packet_t*)request->setup_buffer;
-	request->transfered_size = 0;
-	if(setup_request->request == USB_DEVREQ_CLEAR_FEATURE
-				|| setup_request->request == USB_DEVREQ_SET_FEATURE){
-		if(setup_request->request_type == USB_HUB_REQ_TYPE_SET_HUB_FEATURE){
-			usb_log_debug("USB_HUB_REQ_TYPE_SET_HUB_FEATURE\n");
-			return process_hub_feature_set_request(instance, setup_request->value,
-					setup_request->request == USB_DEVREQ_SET_FEATURE);
-		}
-		if(setup_request->request_type == USB_HUB_REQ_TYPE_SET_PORT_FEATURE){
-			usb_log_debug("USB_HUB_REQ_TYPE_SET_PORT_FEATURE\n");
-			return process_port_feature_set_request(instance, setup_request->value,
-					setup_request->index,
-					setup_request->request == USB_DEVREQ_SET_FEATURE);
-		}
-		usb_log_debug("USB_HUB_REQ_TYPE_INVALID %d\n",setup_request->request_type);
-		return EINVAL;
-	}
-	if(setup_request->request == USB_DEVREQ_SET_ADDRESS){
-		usb_log_debug("USB_DEVREQ_SET_ADDRESS\n");
-		return process_address_set_request(instance, setup_request->value);
-	}
-	usb_log_debug("USB_DEVREQ_SET_ENOTSUP %d\n",setup_request->request_type);
-	return ENOTSUP;
-}
-
-
-/**
- *
- * @param instance
- * @param request
- * @return
- */
 int rh_request(rh_t *instance, usb_transfer_batch_t *request)
 {
 	assert(instance);
 	assert(request);
-	int opResult;
-	if(request->transfer_type == USB_TRANSFER_CONTROL){
-		if (request->setup_buffer) {
-			usb_log_info("Root hub got CTRL packet: %s.\n",
-				usb_debug_str_buffer((const uint8_t *)request->setup_buffer, 8, 8));
-			if(sizeof(usb_device_request_setup_packet_t)>request->setup_size){
-				usb_log_error("setup packet too small\n");
-				return EINVAL;
-			}
-			usb_device_request_setup_packet_t * setup_request =
-					(usb_device_request_setup_packet_t*)request->setup_buffer;
-			if(
-				setup_request->request == USB_DEVREQ_GET_STATUS
-				|| setup_request->request == USB_DEVREQ_GET_DESCRIPTOR
-				|| setup_request->request == USB_DEVREQ_GET_CONFIGURATION
-			){
-				usb_log_debug("processing request with output\n");
-				opResult = process_request_with_output(instance,request);
-			}else if(
-				setup_request->request == USB_DEVREQ_CLEAR_FEATURE
-				|| setup_request->request == USB_DEVREQ_SET_FEATURE
-				|| setup_request->request == USB_DEVREQ_SET_ADDRESS
-			){
-				usb_log_debug("processing request without additional data\n");
-				opResult = process_request_without_data(instance,request);
-			}else if(setup_request->request == USB_DEVREQ_SET_DESCRIPTOR
-					|| setup_request->request == USB_DEVREQ_SET_CONFIGURATION
-			){
-				usb_log_debug("processing request with input\n");
-				opResult = process_request_with_input(instance,request);
-			}else{
-				usb_log_warning("received unsuported request: %d\n",
-						setup_request->request
-						);
-				opResult = ENOTSUP;
-			}
-		}else{
-			usb_log_error("root hub received empty transaction?");
-			opResult = EINVAL;
-		}
-	}else if(request->transfer_type == USB_TRANSFER_INTERRUPT){
-		usb_log_info("Root hub got INTERRUPT packet\n");
-		void * buffer;
-		create_interrupt_mask(instance, &buffer,
-			&(request->transfered_size));
-		memcpy(request->transport_buffer,buffer, request->transfered_size);
-		opResult = EOK;
-	}else{
-		opResult = EINVAL;
+	/* TODO: implement */
+	if (request->setup_buffer) {
+		usb_log_info("Root hub got SETUP packet: %s.\n",
+		    usb_debug_str_buffer((const uint8_t *)request->setup_buffer, 8, 8));
 	}
-	usb_transfer_batch_finish(request, opResult);
+	usb_log_error("Root hub request processing not implemented.\n");
+	usb_transfer_batch_finish(request, ENOTSUP);
 	return EOK;
 }
 /*----------------------------------------------------------------------------*/
-
-
 void rh_interrupt(rh_t *instance)
 {
Index: uspace/drv/ohci/root_hub.h
===================================================================
--- uspace/drv/ohci/root_hub.h	(revision 291b8bc66a941bac60fdea3ad481eb7b27bfcf40)
+++ uspace/drv/ohci/root_hub.h	(revision 889e8e3c68f741489743165141ddb4ccfad90112)
@@ -45,5 +45,4 @@
 	usb_address_t address;
 	ddf_dev_t *device;
-	int port_count;
 } rh_t;
 
